unit Main;

interface

uses
	SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, StdCtrls, Placemnt, drwatch;

const
  Allowed = (['a'..'z', 'A'..'Z', '0'..'9', '_']);

type
	TForm1 = class(TForm)
    lbFiles: TListBox;
		Label1: TLabel;
    btnAdd: TButton;
    btnRemove: TButton;
    edtFind: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    edtReplace: TEdit;
    OpenDialog: TOpenDialog;
    btnStart: TButton;
		cbBackup: TCheckBox;
    FormStorage1: TFormStorage;
    cbWhole: TCheckBox;
    memLog: TMemo;
		btnExit: TButton;
		DropWatch1: TDropWatch;
		Label4: TLabel;
    Button1: TButton;
		procedure btnAddClick(Sender: TObject);
		procedure btnRemoveClick(Sender: TObject);
		procedure btnStartClick(Sender: TObject);
		procedure btnExitClick(Sender: TObject);
		procedure DropWatch1FilesDropped(Sender: TObject; X, Y: Integer;
			Files: TStringList);
    procedure Button1Click(Sender: TObject);
    procedure FormActivate(Sender: TObject);
	private
		procedure UpdateTotalFile;
	public
	end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.btnAddClick(Sender: TObject);
var I: Integer;
begin
	if OpenDialog.Execute then begin
		for I := 0 to OpenDialog.Files.Count - 1 do
			if lbFiles.Items.IndexOf(OpenDialog.Files[I]) < 0 then
				lbFiles.Items.Add(OpenDialog.Files[I]);
		OpenDialog.InitialDir := ExtractFilePath(OpenDialog.Files[0]);
	end;
	UpdateTotalFile;
end;

procedure TForm1.btnRemoveClick(Sender: TObject);
begin
	if lbFiles.ItemIndex >= 0 then
		lbFiles.Items.Delete(lbFiles.ItemIndex);
	UpdateTotalFile;
end;

procedure TForm1.btnStartClick(Sender: TObject);
var
  sFile, sBackUp, sFind, sReplace, S, sRes, sHi: string;
	I, J, P, stPos: Integer;
  slFile: TStrings;
  replCount: Longint;
begin
  slFile := TStringList.Create;
  sFind := AnsiUpperCase(edtFind.Text);
  sReplace := edtReplace.Text;
  memLog.Lines.Add(edtFind.Text + '->' + sReplace);
  for J := 0 to lbFiles.Items.Count - 1 do begin
    replCount := 0;
    sFile := lbFiles.Items.Strings[J];
    sBackUp := ChangeFileExt(sFile, '.~' + Copy(ExtractFileExt(sFile), 2, 2));
    slFile.LoadFromFile(sFile);

    for I := 0 to slFile.Count - 1 do begin
			S := slFile.Strings[I];
      sRes := '';
      sHi := AnsiUpperCase(S);
      P := Pos(sFind, sHi);
      stPos := 0;
      while P > stPos do begin
        if not cbWhole.Checked or
          (((P = 1) or (not (S[P - 1] in Allowed))) and
        ((P + Length(sFind) > Length(S)) or (not (S[P + Length(sFind)] in Allowed)))) then begin
          sRes := sRes + Copy(S, 1, P - 1);
          sRes := sRes + sReplace;
          Delete(S, 1, P + Length(sFind) - 1);
          Delete(sHi, 1, P + Length(sFind) - 1);
          Inc(replCount);
        end else begin
					sRes := sRes + Copy(S, 1, P + Length(sFind) - 1);
          Delete(S, 1, P + Length(sFind) - 1);
          Delete(sHi, 1, P + Length(sFind) - 1);
        end;
        P := Pos(sFind, sHi);
      end;
      slFile.Strings[I] := sRes + S;
    end;

    if replCount > 0 then begin
      if cbBackup.Checked then begin
        if FileExists(sBackUp) then DeleteFile(PCHAR(sBackUp));
        RenameFile(sFile, sBackUp);
      end;
			slFile.SaveToFile(sFile);
		end;
		memLog.Lines.Add(sFile + ' - ' + IntToStr(replCount) + ' replacement(s)');
	end;
	slFile.Free;
end;

procedure TForm1.btnExitClick(Sender: TObject);
begin
	Close;
end;

procedure TForm1.DropWatch1FilesDropped(Sender: TObject; X, Y: Integer;
	Files: TStringList);
begin
	lbFiles.Items.AddStrings(Files);
	UpdateTotalFile;
end;

procedure TForm1.UpdateTotalFile;
begin
	Label4.Caption := IntToStr(lbFiles.Items.Count);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
	lbFiles.Items.Clear;
	UpdateTotalFile;
end;

procedure TForm1.FormActivate(Sender: TObject);
begin
	UpdateTotalFile;
end;

end.
